searchNodes=[{"ref":"OperationError.html","title":"OperationError","type":"exception","doc":"Defines an exception that handles not described WSDL operations."},{"ref":"Soap.html","title":"Soap","type":"module","doc":"The SOAP client for Elixir based on httpc (for send requests) and SwXml (for xml parsing). Soap contains 5 main modules: Soap.Wsdl - Build wsdl components data map. Can parse raw wsdl file from external url or local path. Wsdl which is prepared this module are using for send requests. Soap.Request - Provides functionality for build and calling requests. Contains Request.Headers and Soap.Params submodules for build headers and build body with parameters validation respectively. This module is a wrapper over httpc. It send requests and handle them. Soap.Response - Handle soap response and handle them. It provides functionality for parsing xml-like body and transform it to comfortable structure. Structure for this module returns with necessary data after send a request. Soap.Xsd - This module have same functionality as Soap.Wsdl module, but only for Xsd-files. It allows to parse xsd files from external resources or local path and convert it to map. Soap.Type - Provides a functionality for find and parse complex types from raw xsd file. It uses in library for validation parameters when we build request body. The Soap module can be used to parse WSDL files: iex&gt; Soap.init_model(&quot;https://git.io/vNCWd&quot;, :url) {:ok, %{ complex_types: [...], endpoint: &quot;...&quot;, messages: [...], namespaces: %{...}, operations: [...], schema_attributes: %{...}, soap_version: &quot;x.x&quot;, validation_types: %{...} } } And send requests: iex&gt; Soap.call(wsdl, action, params) {:ok, %Soap.Response{}} It&#39;s very common to use Soap in order to wrap APIs. See call/5 for more details on how to issue requests to soap services"},{"ref":"Soap.html#call/5","title":"Soap.call/5","type":"function","doc":"Send a request to the SOAP server based on the passed WSDL file, action and parameters. Returns {:ok, %Soap.Response{}} if the request is successful, {:error, reason} otherwise. Parameters wsdl: Wsdl model from Soap.init_model/2 function. action: Soap action to be called. Use Soap.operations/1 to get a list of available actions params: Parameters to build the body of a SOAP request. headers: Custom request headers. opts: httpc options. Examples iex&gt; Soap.call(wsdl, action, params) {:ok, %Soap.Response{}}"},{"ref":"Soap.html#init_model/2","title":"Soap.init_model/2","type":"function","doc":"Initialization of a WSDL model. Response a map of parsed data from file. Returns {:ok, wsdl}. Parameters path: Path for wsdl file. type: Atom that represents the type of path for WSDL file. Can be :file or url. Default: :file. Examples iex&gt; {:ok, wsdl} = Soap.init_model(&quot;https://git.io/vNCWd&quot;, :url) {:ok, %{...}}"},{"ref":"Soap.html#operations/1","title":"Soap.operations/1","type":"function","doc":"Returns a list of available actions of the passed WSDL. Parameters wsdl: Wsdl model from Soap.init_model/2 function. Examples iex&gt; {:ok, wsdl} = Soap.init_model(&quot;https://git.io/vNCWd&quot;, :url) iex&gt; Soap.operations(wsdl) [&quot;SendMessage&quot;, &quot;SendMessageMultipleRecipients&quot;]"},{"ref":"Soap.Request.html","title":"Soap.Request","type":"module","doc":"Documentation for Soap.Request."},{"ref":"Soap.Request.html#b2l/1","title":"Soap.Request.b2l/1","type":"function","doc":""},{"ref":"Soap.Request.html#call/5","title":"Soap.Request.call/5","type":"function","doc":"Executing with parsed wsdl and headers with body map. Calling httpc.request by Map with method, url, body, headers, options keys."},{"ref":"Soap.Request.html#get_url/1","title":"Soap.Request.get_url/1","type":"function","doc":""},{"ref":"Soap.Request.Headers.html","title":"Soap.Request.Headers","type":"module","doc":"Headers generator by soap action and custom headers. Examples iex&gt; {:ok, wsdl} = Fixtures.get_file_path(&quot;wsdl/SendService.wsdl&quot;) |&gt; Soap.init_model(:file) ...&gt; Soap.Request.Headers.build(wsdl, &quot;SendMessage&quot;, []) [{&quot;SOAPAction&quot;, &quot;com.esendex.ems.soapinterface/SendMessage&quot;}, {&quot;Content-Type&quot;, &quot;text/xml;charset=utf-8&quot;}]"},{"ref":"Soap.Request.Headers.html#base_headers/1","title":"Soap.Request.Headers.base_headers/1","type":"function","doc":""},{"ref":"Soap.Request.Headers.html#build/3","title":"Soap.Request.Headers.build/3","type":"function","doc":""},{"ref":"Soap.Request.Headers.html#extract_headers/2","title":"Soap.Request.Headers.extract_headers/2","type":"function","doc":""},{"ref":"Soap.Request.Headers.html#extract_soap_action_by_operation/2","title":"Soap.Request.Headers.extract_soap_action_by_operation/2","type":"function","doc":""},{"ref":"Soap.Request.Params.html","title":"Soap.Request.Params","type":"module","doc":"Documentation for Soap.Request.Options."},{"ref":"Soap.Request.Params.html#add_action_tag_wrapper/3","title":"Soap.Request.Params.add_action_tag_wrapper/3","type":"function","doc":""},{"ref":"Soap.Request.Params.html#add_body_tag_wrapper/1","title":"Soap.Request.Params.add_body_tag_wrapper/1","type":"function","doc":""},{"ref":"Soap.Request.Params.html#add_envelope_tag_wrapper/3","title":"Soap.Request.Params.add_envelope_tag_wrapper/3","type":"function","doc":""},{"ref":"Soap.Request.Params.html#add_header_part_tag_wrapper/3","title":"Soap.Request.Params.add_header_part_tag_wrapper/3","type":"function","doc":""},{"ref":"Soap.Request.Params.html#add_header_tag_wrapper/1","title":"Soap.Request.Params.add_header_tag_wrapper/1","type":"function","doc":""},{"ref":"Soap.Request.Params.html#build_action_attribute/2","title":"Soap.Request.Params.build_action_attribute/2","type":"function","doc":""},{"ref":"Soap.Request.Params.html#build_body/4","title":"Soap.Request.Params.build_body/4","type":"function","doc":"Parsing parameters map and generate body xml by given soap action name and body params(Map). Returns xml-like string."},{"ref":"Soap.Request.Params.html#build_soap_body/3","title":"Soap.Request.Params.build_soap_body/3","type":"function","doc":""},{"ref":"Soap.Request.Params.html#build_soap_header/3","title":"Soap.Request.Params.build_soap_header/3","type":"function","doc":""},{"ref":"Soap.Request.Params.html#build_soap_version_attribute/1","title":"Soap.Request.Params.build_soap_version_attribute/1","type":"function","doc":""},{"ref":"Soap.Request.Params.html#construct_xml_request_body/1","title":"Soap.Request.Params.construct_xml_request_body/1","type":"function","doc":""},{"ref":"Soap.Request.Params.html#construct_xml_request_header/1","title":"Soap.Request.Params.construct_xml_request_header/1","type":"function","doc":""},{"ref":"Soap.Request.Params.html#custom_namespaces/0","title":"Soap.Request.Params.custom_namespaces/0","type":"function","doc":""},{"ref":"Soap.Request.Params.html#env_namespace/0","title":"Soap.Request.Params.env_namespace/0","type":"function","doc":""},{"ref":"Soap.Request.Params.html#format_error_message/2","title":"Soap.Request.Params.format_error_message/2","type":"function","doc":""},{"ref":"Soap.Request.Params.html#get_action_namespace/2","title":"Soap.Request.Params.get_action_namespace/2","type":"function","doc":""},{"ref":"Soap.Request.Params.html#get_action_with_namespace/2","title":"Soap.Request.Params.get_action_with_namespace/2","type":"function","doc":""},{"ref":"Soap.Request.Params.html#get_header_with_namespace/2","title":"Soap.Request.Params.get_header_with_namespace/2","type":"function","doc":""},{"ref":"Soap.Request.Params.html#get_message_part/3","title":"Soap.Request.Params.get_message_part/3","type":"function","doc":""},{"ref":"Soap.Request.Params.html#handle_action_extractor_result/3","title":"Soap.Request.Params.handle_action_extractor_result/3","type":"function","doc":""},{"ref":"Soap.Request.Params.html#handle_element_form_default/1","title":"Soap.Request.Params.handle_element_form_default/1","type":"function","doc":""},{"ref":"Soap.Request.Params.html#insert_tag_parameters/1","title":"Soap.Request.Params.insert_tag_parameters/1","type":"function","doc":""},{"ref":"Soap.Request.Params.html#prepare_action_attribute/2","title":"Soap.Request.Params.prepare_action_attribute/2","type":"function","doc":""},{"ref":"Soap.Request.Params.html#prepare_action_tag/2","title":"Soap.Request.Params.prepare_action_tag/2","type":"function","doc":""},{"ref":"Soap.Request.Params.html#soap_version/1","title":"Soap.Request.Params.soap_version/1","type":"function","doc":""},{"ref":"Soap.Request.Params.html#type_error_message/2","title":"Soap.Request.Params.type_error_message/2","type":"function","doc":""},{"ref":"Soap.Request.Params.html#validate_param/3","title":"Soap.Request.Params.validate_param/3","type":"function","doc":""},{"ref":"Soap.Request.Params.html#validate_param_attributes/3","title":"Soap.Request.Params.validate_param_attributes/3","type":"function","doc":""},{"ref":"Soap.Request.Params.html#validate_params/3","title":"Soap.Request.Params.validate_params/3","type":"function","doc":""},{"ref":"Soap.Request.Params.html#validate_type/3","title":"Soap.Request.Params.validate_type/3","type":"function","doc":""},{"ref":"Soap.Response.html","title":"Soap.Response","type":"module","doc":"Struct for response given by soap call."},{"ref":"Soap.Response.html#parse/1","title":"Soap.Response.parse/1","type":"function","doc":"Executing with xml response body as string. Function parse/1 returns a full parsed response structure as map."},{"ref":"Soap.Response.html#parse/2","title":"Soap.Response.parse/2","type":"function","doc":""},{"ref":"Soap.Response.html#t:t/0","title":"Soap.Response.t/0","type":"type","doc":""},{"ref":"Soap.Response.Parser.html","title":"Soap.Response.Parser","type":"module","doc":"Provides a functions for parse an xml-like response body."},{"ref":"Soap.Response.Parser.html#apply_namespace_to_tag/2","title":"Soap.Response.Parser.apply_namespace_to_tag/2","type":"function","doc":""},{"ref":"Soap.Response.Parser.html#extract_value_from_list/1","title":"Soap.Response.Parser.extract_value_from_list/1","type":"function","doc":""},{"ref":"Soap.Response.Parser.html#get_body_tag/1","title":"Soap.Response.Parser.get_body_tag/1","type":"function","doc":""},{"ref":"Soap.Response.Parser.html#get_envelope_namespace/1","title":"Soap.Response.Parser.get_envelope_namespace/1","type":"function","doc":""},{"ref":"Soap.Response.Parser.html#get_fault_tag/1","title":"Soap.Response.Parser.get_fault_tag/1","type":"function","doc":""},{"ref":"Soap.Response.Parser.html#parse/2","title":"Soap.Response.Parser.parse/2","type":"function","doc":"Executing with xml response body. If a list is empty then parse/1 returns full parsed response structure into map."},{"ref":"Soap.Response.Parser.html#parse_element_values/1","title":"Soap.Response.Parser.parse_element_values/1","type":"function","doc":""},{"ref":"Soap.Response.Parser.html#parse_elements/1","title":"Soap.Response.Parser.parse_elements/1","type":"function","doc":""},{"ref":"Soap.Response.Parser.html#parse_record/1","title":"Soap.Response.Parser.parse_record/1","type":"function","doc":""},{"ref":"Soap.Response.Parser.html#soap_version/0","title":"Soap.Response.Parser.soap_version/0","type":"function","doc":""},{"ref":"Soap.Response.Parser.html#transform_record_value/1","title":"Soap.Response.Parser.transform_record_value/1","type":"function","doc":""},{"ref":"Soap.Response.Parser.html#unique_tags?/1","title":"Soap.Response.Parser.unique_tags?/1","type":"function","doc":""},{"ref":"Soap.Type.html","title":"Soap.Type","type":"module","doc":"Provides functions for parsing types to struct"},{"ref":"Soap.Type.html#get_complex_types/2","title":"Soap.Type.get_complex_types/2","type":"function","doc":""},{"ref":"Soap.Type.html#parse_type_attributes/2","title":"Soap.Type.parse_type_attributes/2","type":"function","doc":""},{"ref":"Soap.Type.html#parse_types/2","title":"Soap.Type.parse_types/2","type":"function","doc":""},{"ref":"Soap.Wsdl.html","title":"Soap.Wsdl","type":"module","doc":"Provides functions for parsing wsdl file"},{"ref":"Soap.Wsdl.html#get_complex_types/3","title":"Soap.Wsdl.get_complex_types/3","type":"function","doc":""},{"ref":"Soap.Wsdl.html#get_endpoint/3","title":"Soap.Wsdl.get_endpoint/3","type":"function","doc":""},{"ref":"Soap.Wsdl.html#get_full_paths/4","title":"Soap.Wsdl.get_full_paths/4","type":"function","doc":""},{"ref":"Soap.Wsdl.html#get_imported_types/1","title":"Soap.Wsdl.get_imported_types/1","type":"function","doc":""},{"ref":"Soap.Wsdl.html#get_message_parts/2","title":"Soap.Wsdl.get_message_parts/2","type":"function","doc":""},{"ref":"Soap.Wsdl.html#get_messages/2","title":"Soap.Wsdl.get_messages/2","type":"function","doc":""},{"ref":"Soap.Wsdl.html#get_namespace/4","title":"Soap.Wsdl.get_namespace/4","type":"function","doc":""},{"ref":"Soap.Wsdl.html#get_namespaces/3","title":"Soap.Wsdl.get_namespaces/3","type":"function","doc":""},{"ref":"Soap.Wsdl.html#get_operation_input/3","title":"Soap.Wsdl.get_operation_input/3","type":"function","doc":""},{"ref":"Soap.Wsdl.html#get_operations/3","title":"Soap.Wsdl.get_operations/3","type":"function","doc":""},{"ref":"Soap.Wsdl.html#get_protocol_namespace/1","title":"Soap.Wsdl.get_protocol_namespace/1","type":"function","doc":""},{"ref":"Soap.Wsdl.html#get_schema_attributes/1","title":"Soap.Wsdl.get_schema_attributes/1","type":"function","doc":""},{"ref":"Soap.Wsdl.html#get_schema_imports/3","title":"Soap.Wsdl.get_schema_imports/3","type":"function","doc":""},{"ref":"Soap.Wsdl.html#get_schema_namespace/1","title":"Soap.Wsdl.get_schema_namespace/1","type":"function","doc":""},{"ref":"Soap.Wsdl.html#get_soap_namespace/2","title":"Soap.Wsdl.get_soap_namespace/2","type":"function","doc":""},{"ref":"Soap.Wsdl.html#get_validation_types/4","title":"Soap.Wsdl.get_validation_types/4","type":"function","doc":""},{"ref":"Soap.Wsdl.html#imports/0","title":"Soap.Wsdl.imports/0","type":"function","doc":""},{"ref":"Soap.Wsdl.html#ns/2","title":"Soap.Wsdl.ns/2","type":"function","doc":""},{"ref":"Soap.Wsdl.html#parse/3","title":"Soap.Wsdl.parse/3","type":"function","doc":""},{"ref":"Soap.Wsdl.html#parse_from_file/2","title":"Soap.Wsdl.parse_from_file/2","type":"function","doc":""},{"ref":"Soap.Wsdl.html#parse_from_url/2","title":"Soap.Wsdl.parse_from_url/2","type":"function","doc":""},{"ref":"Soap.Wsdl.html#soap_version/0","title":"Soap.Wsdl.soap_version/0","type":"function","doc":""},{"ref":"Soap.Wsdl.html#soap_version/1","title":"Soap.Wsdl.soap_version/1","type":"function","doc":""},{"ref":"Soap.Xsd.html","title":"Soap.Xsd","type":"module","doc":"Provides functions for parsing xsd file"},{"ref":"Soap.Xsd.html#get_simple_types/1","title":"Soap.Xsd.get_simple_types/1","type":"function","doc":""},{"ref":"Soap.Xsd.html#parse/1","title":"Soap.Xsd.parse/1","type":"function","doc":""},{"ref":"Soap.Xsd.html#parse_from_file/1","title":"Soap.Xsd.parse_from_file/1","type":"function","doc":""},{"ref":"Soap.Xsd.html#parse_from_url/1","title":"Soap.Xsd.parse_from_url/1","type":"function","doc":""},{"ref":"Soap.Xsd.html#parse_xsd/1","title":"Soap.Xsd.parse_xsd/1","type":"function","doc":""},{"ref":"SwXml.html","title":"SwXml","type":"module","doc":"SwXml is a thin wrapper around :xmerl. It allows you to convert a string or xmlElement record as defined in :xmerl to an elixir value such as map, list, char_list, or any combination of these. For normal sized documents, SwXml primarily exposes 3 functions SwXml.xpath/2 - return a value based on the xpath expression SwXml.xpath/3 - similar to above but allowing nesting of mapping SwXml.xmap/2 - return a map with keywords mapped to values returned from xpath For something larger, SwXml mainly exposes 1 function SwXml.stream_tags/3 - stream a given tag or a list of tags, and optionally &quot;discard&quot; some dom elements in order to free memory during streaming for big files which cannot fit entirely in memory Examples Simple Xpath iex&gt; import SwXml iex&gt; doc = &quot;&lt;h1&gt;&lt;a&gt;Some linked title&lt;/a&gt;&lt;/h1&gt;&quot; iex&gt; doc |&gt; xpath(~x&quot;//a/text()&quot;) &#39;Some linked title&#39; Nested Mapping iex&gt; import SwXml iex&gt; doc = &quot;&lt;body&gt;&lt;header&gt;&lt;p&gt;Message&lt;/p&gt;&lt;ul&gt;&lt;li&gt;One&lt;/li&gt;&lt;li&gt;&lt;a&gt;Two&lt;/a&gt;&lt;/li&gt;&lt;/ul&gt;&lt;/header&gt;&lt;/body&gt;&quot; iex&gt; doc |&gt; xpath(~x&quot;//header&quot;, message: ~x&quot;./p/text()&quot;, a_in_li: ~x&quot;.//li/a/text()&quot;l) %{a_in_li: [&#39;Two&#39;], message: &#39;Message&#39;} Streaming iex&gt; import SwXml iex&gt; doc = [&quot;&lt;ul&gt;&lt;li&gt;l1&lt;/li&gt;&lt;li&gt;l2&quot;, &quot;&lt;/li&gt;&lt;li&gt;l3&lt;/li&gt;&lt;/ul&gt;&quot;] iex&gt; SwXml.stream_tags(doc, :li) ...&gt; |&gt; Stream.map(fn {:li, doc} -&gt; ...&gt; doc |&gt; SwXml.xpath(~x&quot;./text()&quot;) ...&gt; end) ...&gt; |&gt; Enum.to_list [&#39;l1&#39;, &#39;l2&#39;, &#39;l3&#39;] For more examples please see help for each individual functions The ~x Sigil Notice in the above examples, we used the expression ~x&quot;//a/text()&quot; to define the path. The reason is it allows us to more precisely specify what is being returned. ~x&quot;//some/path&quot; without any modifiers, xpath/2 will return the value of the entity if the entity is of type xmlText, xmlAttribute, xmlPI, xmlComment as defined in :xmerl ~x&quot;//some/path&quot;e e stands for (e)ntity. This forces xpath/2 to return the entity with which you can further chain your xpath/2 call ~x&quot;//some/path&quot;l &#39;l&#39; stands for (l)ist. This forces xpath/2 to return a list. Without l, xpath/2 will only return the first element of the match ~x&quot;//some/path&quot;el - mix of the above ~x&quot;//some/path&quot;k &#39;k&#39; stands for (K)eyword. This forces xpath/2 to return a Keyword instead of a Map. ~x&quot;//some/path&quot;s &#39;s&#39; stands for (s)tring. This forces xpath/2 to return the value as string instead of a char list. x&quot;//some/path&quot;o &#39;o&#39; stands for (O)ptional. This allows the path to not exist, and will return nil. ~x&quot;//some/path&quot;sl - string list. Notice also in the examples section, we always import SwXml first. This makes x_sigil available in the current scope. Without it, instead of using ~x, you can do the following iex&gt; doc = &quot;&lt;h1&gt;&lt;a&gt;Some linked title&lt;/a&gt;&lt;/h1&gt;&quot; iex&gt; doc |&gt; SwXml.xpath(%SwXpath{path: &#39;//a/text()&#39;, is_value: true, cast_to: false, is_list: false, is_keyword: false}) &#39;Some linked title&#39; Note the use of char_list in the path definition."},{"ref":"SwXml.html#add_namespace/3","title":"SwXml.add_namespace/3","type":"function","doc":""},{"ref":"SwXml.html#parse/1","title":"SwXml.parse/1","type":"function","doc":"doc can be a byte list (iodata) a binary any enumerable of binaries (for instance File.stream!/3 result) options are xmerl options described here http://www.erlang.org/doc/man/xmerl_scan.html, see the erlang tutorial for usage. When doc is an enumerable, the :cont_fun option cannot be given. Return an xmlElement record"},{"ref":"SwXml.html#parse/2","title":"SwXml.parse/2","type":"function","doc":""},{"ref":"SwXml.html#sigil_x/2","title":"SwXml.sigil_x/2","type":"function","doc":"sigil_x/2 simply returns a SwXpath struct, with modifiers converted to boolean fields iex&gt; SwXml.sigil_x(&quot;//some/path&quot;, &#39;e&#39;) %SwXpath{path: &#39;//some/path&#39;, is_value: false, cast_to: false, is_list: false, is_keyword: false} or you can simply import and use the ~x expression iex&gt; import SwXml iex&gt; ~x&quot;//some/path&quot;e %SwXpath{path: &#39;//some/path&#39;, is_value: false, cast_to: false, is_list: false, is_keyword: false} Valid modifiers are e, s, l and k. Below is the full explanation ~x&quot;//some/path&quot; without any modifiers, xpath/2 will return the value of the entity if the entity is of type xmlText, xmlAttribute, xmlPI, xmlComment as defined in :xmerl ~x&quot;//some/path&quot;e e stands for (e)ntity. This forces xpath/2 to return the entity with which you can further chain your xpath/2 call ~x&quot;//some/path&quot;l &#39;l&#39; stands for (l)ist. This forces xpath/2 to return a list. Without l, xpath/2 will only return the first element of the match ~x&quot;//some/path&quot;el - mix of the above ~x&quot;//some/path&quot;k &#39;k&#39; stands for (K)eyword. This forces xpath/2 to return a Keyword instead of a Map. ~x&quot;//some/path&quot;s &#39;s&#39; stands for (s)tring. This forces xpath/2 to return the value as string instead of a char list. x&quot;//some/path&quot;o &#39;o&#39; stands for (O)ptional. This allows the path to not exist, and will return nil. ~x&quot;//some/path&quot;sl - string list. ~x&quot;//some/path&quot;i &#39;i&#39; stands for (i)nteger. This forces xpath/2 to return the value as integer instead of a char list. ~x&quot;//some/path&quot;f &#39;f&#39; stands for (f)loat. This forces xpath/2 to return the value as float instead of a char list. ~x&quot;//some/path&quot;il - integer list"},{"ref":"SwXml.html#stream/2","title":"SwXml.stream/2","type":"function","doc":"Create an element stream from a xml doc. This is a lower level API compared to SwXml.stream_tags. You can use the options_callback argument to get fine control of what data to be streamed. doc is an enumerable, data will be pulled during the result stream enumeration. e.g. File.stream!(&quot;some_file.xml&quot;) options_callback is an anonymous function fn emit -&gt; xmerl_opts use it to define your :xmerl callbacks and put data into the stream using emit.(elem) in the callbacks. For example, here you define a stream of all xmlElement : iex&gt; import Record iex&gt; doc = [&quot;&lt;h1&quot;, &quot;&gt;&lt;a&gt;Som&quot;, &quot;e linked title&lt;/a&gt;&lt;a&gt;other&lt;/a&gt;&lt;/h1&gt;&quot;] iex&gt; SwXml.stream(doc, fn emit -&gt; ...&gt; [ ...&gt; hook_fun: fn ...&gt; entity, xstate when is_record(entity, :xmlElement)-&gt; ...&gt; emit.(entity) ...&gt; {entity, xstate} ...&gt; entity, xstate -&gt; ...&gt; {entity,xstate} ...&gt; end ...&gt; ] ...&gt; end) |&gt; Enum.count 3"},{"ref":"SwXml.html#stream_tags/3","title":"SwXml.stream_tags/3","type":"function","doc":"Most common usage of streaming: stream a given tag or a list of tags, and optionally &quot;discard&quot; some dom elements in order to free memory during streaming for big files which cannot fit entirely in memory. Note that each matched tag produces it&#39;s own tree. If a given tag appears in the discarded options, it is ignored. doc is an enumerable, data will be pulled during the result stream enumeration. e.g. File.stream!(&quot;some_file.xml&quot;) tags is an atom or a list of atoms you want to extract. Each stream element will be {:tagname, xmlelem}. e.g. :li, :header options[:discard] is the list of tag which will be discarded: not added to its parent DOM. Examples: iex&gt; import SwXml iex&gt; doc = [&quot;&lt;ul&gt;&lt;li&gt;l1&lt;/li&gt;&lt;li&gt;l2&quot;, &quot;&lt;/li&gt;&lt;li&gt;l3&lt;/li&gt;&lt;/ul&gt;&quot;] iex&gt; SwXml.stream_tags(doc, :li, discard: [:li]) ...&gt; |&gt; Stream.map(fn {:li, doc} -&gt; doc |&gt; SwXml.xpath(~x&quot;./text()&quot;) end) ...&gt; |&gt; Enum.to_list [&#39;l1&#39;, &#39;l2&#39;, &#39;l3&#39;] iex&gt; SwXml.stream_tags(doc, [:ul, :li]) ...&gt; |&gt; Stream.map(fn {_, doc} -&gt; doc |&gt; SwXml.xpath(~x&quot;./text()&quot;) end) ...&gt; |&gt; Enum.to_list [&#39;l1&#39;, &#39;l2&#39;, &#39;l3&#39;, nil] Becareful if you set options[:discard]. If any of the discarded tags is nested inside a kept tag, you will not be able to access them. Examples: iex&gt; import SwXml iex&gt; doc = [&quot;&lt;header&gt;&quot;, &quot;&lt;title&gt;XML&lt;/title&quot;, &quot;&gt;&lt;header&gt;&lt;title&gt;Nested&lt;/title&gt;&lt;/header&gt;&lt;/header&gt;&quot;] iex&gt; SwXml.stream_tags(doc, :header) ...&gt; |&gt; Stream.map(fn {_, doc} -&gt; SwXml.xpath(doc, ~x&quot;.//title/text()&quot;) end) ...&gt; |&gt; Enum.to_list [&#39;Nested&#39;, &#39;XML&#39;] iex&gt; SwXml.stream_tags(doc, :header, discard: [:title]) ...&gt; |&gt; Stream.map(fn {_, doc} -&gt; SwXml.xpath(doc, ~x&quot;./title/text()&quot;) end) ...&gt; |&gt; Enum.to_list [nil, nil]"},{"ref":"SwXml.html#transform_by/2","title":"SwXml.transform_by/2","type":"function","doc":"Tags %SwXpath{} with fun to be applied at the end of xpath query. Examples iex&gt; import SwXml iex&gt; string_to_range = fn str -&gt; ...&gt; [first, last] = str |&gt; String.split(&quot;-&quot;, trim: true) |&gt; Enum.map(&amp;String.to_integer/1) ...&gt; first..last ...&gt; end iex&gt; doc = &quot;north5-15&quot; iex&gt; doc ...&gt; |&gt; xpath( ...&gt; ~x&quot;//weather/zone&quot;l, ...&gt; name: ~x&quot;//name/text()&quot;s |&gt; transform_by(&amp;String.capitalize/1), ...&gt; wind_speed: ~x&quot;./wind-speed/text()&quot;s |&gt; transform_by(string_to_range) ...&gt; ) [%{name: &quot;North&quot;, wind_speed: 5..15}]"},{"ref":"SwXml.html#xmap/2","title":"SwXml.xmap/2","type":"function","doc":"xmap returns a mapping with each value being the result of xpath Just as xpath, you can nest the mapping structure. Please see xpath for more detail. Examples Simple iex&gt; import SwXml iex&gt; doc = &quot;&lt;h1&gt;&lt;a&gt;Some linked title&lt;/a&gt;&lt;/h1&gt;&quot; iex&gt; doc |&gt; xmap(a: ~x&quot;//a/text()&quot;) %{a: &#39;Some linked title&#39;} With optional mapping iex&gt; import SwXml iex&gt; doc = &quot;&lt;body&gt;&lt;header&gt;&lt;p&gt;Message&lt;/p&gt;&lt;ul&gt;&lt;li&gt;One&lt;/li&gt;&lt;li&gt;&lt;a&gt;Two&lt;/a&gt;&lt;/li&gt;&lt;/ul&gt;&lt;/header&gt;&lt;/body&gt;&quot; iex&gt; doc |&gt; xmap(message: ~x&quot;//p/text()&quot;, a_in_li: ~x&quot;.//li/a/text()&quot;l) %{a_in_li: [&#39;Two&#39;], message: &#39;Message&#39;} With optional mapping and nesting iex&gt; import SwXml iex&gt; doc = &quot;&lt;body&gt;&lt;header&gt;&lt;p&gt;Message&lt;/p&gt;&lt;ul&gt;&lt;li&gt;One&lt;/li&gt;&lt;li&gt;&lt;a&gt;Two&lt;/a&gt;&lt;/li&gt;&lt;/ul&gt;&lt;/header&gt;&lt;/body&gt;&quot; iex&gt; doc ...&gt; |&gt; xmap( ...&gt; message: ~x&quot;//p/text()&quot;, ...&gt; ul: [ ...&gt; ~x&quot;//ul&quot;, ...&gt; a: ~x&quot;./li/a/text()&quot; ...&gt; ] ...&gt; ) %{message: &#39;Message&#39;, ul: %{a: &#39;Two&#39;}} iex&gt; doc ...&gt; |&gt; xmap( ...&gt; message: ~x&quot;//p/text()&quot;, ...&gt; ul: [ ...&gt; ~x&quot;//ul&quot;k, ...&gt; a: ~x&quot;./li/a/text()&quot; ...&gt; ] ...&gt; ) %{message: &#39;Message&#39;, ul: [a: &#39;Two&#39;]} iex&gt; doc ...&gt; |&gt; xmap([ ...&gt; message: ~x&quot;//p/text()&quot;, ...&gt; ul: [ ...&gt; ~x&quot;//ul&quot;, ...&gt; a: ~x&quot;./li/a/text()&quot; ...&gt; ] ...&gt; ], true) [message: &#39;Message&#39;, ul: %{a: &#39;Two&#39;}]"},{"ref":"SwXml.html#xmap/3","title":"SwXml.xmap/3","type":"function","doc":""},{"ref":"SwXml.html#xmlAttribute/1","title":"SwXml.xmlAttribute/1","type":"macro","doc":""},{"ref":"SwXml.html#xmlAttribute/2","title":"SwXml.xmlAttribute/2","type":"macro","doc":""},{"ref":"SwXml.html#xmlComment/1","title":"SwXml.xmlComment/1","type":"macro","doc":""},{"ref":"SwXml.html#xmlComment/2","title":"SwXml.xmlComment/2","type":"macro","doc":""},{"ref":"SwXml.html#xmlDecl/1","title":"SwXml.xmlDecl/1","type":"macro","doc":""},{"ref":"SwXml.html#xmlDecl/2","title":"SwXml.xmlDecl/2","type":"macro","doc":""},{"ref":"SwXml.html#xmlDocument/1","title":"SwXml.xmlDocument/1","type":"macro","doc":""},{"ref":"SwXml.html#xmlDocument/2","title":"SwXml.xmlDocument/2","type":"macro","doc":""},{"ref":"SwXml.html#xmlElement/1","title":"SwXml.xmlElement/1","type":"macro","doc":""},{"ref":"SwXml.html#xmlElement/2","title":"SwXml.xmlElement/2","type":"macro","doc":""},{"ref":"SwXml.html#xmlNamespace/1","title":"SwXml.xmlNamespace/1","type":"macro","doc":""},{"ref":"SwXml.html#xmlNamespace/2","title":"SwXml.xmlNamespace/2","type":"macro","doc":""},{"ref":"SwXml.html#xmlNsNode/1","title":"SwXml.xmlNsNode/1","type":"macro","doc":""},{"ref":"SwXml.html#xmlNsNode/2","title":"SwXml.xmlNsNode/2","type":"macro","doc":""},{"ref":"SwXml.html#xmlObj/1","title":"SwXml.xmlObj/1","type":"macro","doc":""},{"ref":"SwXml.html#xmlObj/2","title":"SwXml.xmlObj/2","type":"macro","doc":""},{"ref":"SwXml.html#xmlPI/1","title":"SwXml.xmlPI/1","type":"macro","doc":""},{"ref":"SwXml.html#xmlPI/2","title":"SwXml.xmlPI/2","type":"macro","doc":""},{"ref":"SwXml.html#xmlText/1","title":"SwXml.xmlText/1","type":"macro","doc":""},{"ref":"SwXml.html#xmlText/2","title":"SwXml.xmlText/2","type":"macro","doc":""},{"ref":"SwXml.html#xpath/2","title":"SwXml.xpath/2","type":"function","doc":"xpath allows you to query an xml document with xpath. The second argument to xpath is a SwXpath struct. The optional third argument is a keyword list, such that the value of each keyword is also either a SwXpath or a list with head being a SwXpath and tail being another keyword list exactly like before. Please see examples below for better understanding. Examples Simple iex&gt; import SwXml iex&gt; doc = &quot;&lt;h1&gt;&lt;a&gt;Some linked title&lt;/a&gt;&lt;/h1&gt;&quot; iex&gt; doc |&gt; xpath(~x&quot;//a/text()&quot;) &#39;Some linked title&#39; With optional mapping iex&gt; import SwXml iex&gt; doc = &quot;&lt;body&gt;&lt;header&gt;&lt;p&gt;Message&lt;/p&gt;&lt;ul&gt;&lt;li&gt;One&lt;/li&gt;&lt;li&gt;&lt;a&gt;Two&lt;/a&gt;&lt;/li&gt;&lt;/ul&gt;&lt;/header&gt;&lt;/body&gt;&quot; iex&gt; doc |&gt; xpath(~x&quot;//header&quot;, message: ~x&quot;./p/text()&quot;, a_in_li: ~x&quot;.//li/a/text()&quot;l) %{a_in_li: [&#39;Two&#39;], message: &#39;Message&#39;} With optional mapping and nesting iex&gt; import SwXml iex&gt; doc = &quot;&lt;body&gt;&lt;header&gt;&lt;p&gt;Message&lt;/p&gt;&lt;ul&gt;&lt;li&gt;One&lt;/li&gt;&lt;li&gt;&lt;a&gt;Two&lt;/a&gt;&lt;/li&gt;&lt;/ul&gt;&lt;/header&gt;&lt;/body&gt;&quot; iex&gt; doc ...&gt; |&gt; xpath( ...&gt; ~x&quot;//header&quot;, ...&gt; ul: [ ...&gt; ~x&quot;./ul&quot;, ...&gt; a: ~x&quot;./li/a/text()&quot; ...&gt; ] ...&gt; ) %{ul: %{a: &#39;Two&#39;}}"},{"ref":"SwXml.html#xpath/3","title":"SwXml.xpath/3","type":"function","doc":""},{"ref":"SwXpath.html","title":"SwXpath","type":"module","doc":""},{"ref":"XmlGen.html","title":"XmlGen","type":"module","doc":"A module for generating XML Examples iex&gt; XmlGen.document(:person) |&gt; XmlGen.generate &quot;&lt;?xml version=\\&quot;1.0\\&quot; encoding=\\&quot;UTF-8\\&quot;?&gt;\\n&lt;person/&gt;&quot; iex&gt; XmlGen.document(:person, &quot;Josh&quot;) |&gt; XmlGen.generate &quot;&lt;?xml version=\\&quot;1.0\\&quot; encoding=\\&quot;UTF-8\\&quot;?&gt;\\n&lt;person&gt;Josh&lt;/person&gt;&quot; iex&gt; XmlGen.document(:person) |&gt; XmlGen.generate(format: :none) &quot;&lt;?xml version=\\&quot;1.0\\&quot; encoding=\\&quot;UTF-8\\&quot;?&gt;&lt;person/&gt;&quot; iex&gt; XmlGen.element(:person, &quot;Josh&quot;) |&gt; XmlGen.generate &quot;&lt;person&gt;Josh&lt;/person&gt;&quot; iex&gt; XmlGen.element(:person, %{occupation: &quot;Developer&quot;}, &quot;Josh&quot;) |&gt; XmlGen.generate &quot;&lt;person occupation=\\&quot;Developer\\&quot;&gt;Josh&lt;/person&gt;&quot;"},{"ref":"XmlGen.html#doctype/2","title":"XmlGen.doctype/2","type":"function","doc":"Creates a DOCTYPE declaration with a public identifier. Returns a tuple in the format {:doctype, [:public, name, public_identifier, system_identifier}. Example import XmlGen document([ doctype(&quot;html&quot;, public: [&quot;-//W3C//DTD XHTML 1.0 Transitional//EN&quot;, &quot;http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd&quot;]), element(:html, &quot;Hello, world!&quot;) ]) |&gt; generate Outputs &lt;?xml version=&quot;1.0&quot; encoding=&quot;UTF-8&quot;?&gt; &lt;!DOCTYPE html PUBLIC &quot;-//W3C//DTD XHTML 1.0 Transitional//EN&quot; &quot;http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd&quot;&gt; &lt;html&gt;Hello, world!&lt;/html&gt;"},{"ref":"XmlGen.html#document/1","title":"XmlGen.document/1","type":"function","doc":"Generate an XML document. Returns a binary. Examples iex&gt; XmlGen.document(:person) |&gt; XmlGen.generate &quot;&lt;?xml version=\\&quot;1.0\\&quot; encoding=\\&quot;UTF-8\\&quot;?&gt;\\n&lt;person/&gt;&quot; iex&gt; XmlGen.document(:person, %{id: 1}) |&gt; XmlGen.generate &quot;&lt;?xml version=\\&quot;1.0\\&quot; encoding=\\&quot;UTF-8\\&quot;?&gt;\\n&lt;person id=\\&quot;1\\&quot;/&gt;&quot; iex&gt; XmlGen.document(:person, %{id: 1}, &quot;some data&quot;) |&gt; XmlGen.generate &quot;&lt;?xml version=\\&quot;1.0\\&quot; encoding=\\&quot;UTF-8\\&quot;?&gt;\\n&lt;person id=\\&quot;1\\&quot;&gt;some data&lt;/person&gt;&quot;"},{"ref":"XmlGen.html#document/2","title":"XmlGen.document/2","type":"function","doc":""},{"ref":"XmlGen.html#document/3","title":"XmlGen.document/3","type":"function","doc":""},{"ref":"XmlGen.html#element/1","title":"XmlGen.element/1","type":"function","doc":"Create an XML element. Returns a tuple in the format {name, attributes, content | list}. Examples iex&gt; XmlGen.element(:person) {:person, nil, nil} iex&gt; XmlGen.element(:person, &quot;data&quot;) {:person, nil, &quot;data&quot;} iex&gt; XmlGen.element(:person, %{id: 1}) {:person, %{id: 1}, nil} iex&gt; XmlGen.element(:person, %{id: 1}, &quot;data&quot;) {:person, %{id: 1}, &quot;data&quot;} iex&gt; XmlGen.element(:person, %{id: 1}, [XmlGen.element(:first, &quot;Steve&quot;), XmlGen.element(:last, &quot;Jobs&quot;)]) {:person, %{id: 1}, [ {:first, nil, &quot;Steve&quot;}, {:last, nil, &quot;Jobs&quot;} ]}"},{"ref":"XmlGen.html#element/2","title":"XmlGen.element/2","type":"function","doc":""},{"ref":"XmlGen.html#element/3","title":"XmlGen.element/3","type":"function","doc":""},{"ref":"XmlGen.html#generate/2","title":"XmlGen.generate/2","type":"function","doc":"Generate a binary from an XML tree Returns a binary. Examples iex&gt; XmlGen.generate(XmlGen.element(:person)) &quot;&lt;person/&gt;&quot; iex&gt; XmlGen.generate({:person, %{id: 1}, &quot;Steve Jobs&quot;}) &quot;&lt;person id=\\&quot;1\\&quot;&gt;Steve Jobs&lt;/person&gt;&quot; iex&gt; XmlGen.generate({:name, nil, [{:first, nil, &quot;Steve&quot;}]}, format: :none) &quot;&lt;name&gt;&lt;first&gt;Steve&lt;/first&gt;&lt;/name&gt;&quot; iex&gt; XmlGen.generate({:name, nil, [{:first, nil, &quot;Steve&quot;}]}, whitespace: &quot;&quot;) &quot;&lt;name&gt;\\n&lt;first&gt;Steve&lt;/first&gt;\\n&lt;/name&gt;&quot; iex&gt; XmlGen.generate({:name, nil, [{:first, nil, &quot;Steve&quot;}]}) &quot;&lt;name&gt;\\n &lt;first&gt;Steve&lt;/first&gt;\\n&lt;/name&gt;&quot; iex&gt; XmlGen.generate(:xml_decl, encoding: &quot;ISO-8859-1&quot;) ~s|&lt;?xml version=&quot;1.0&quot; encoding=&quot;ISO-8859-1&quot;?&gt;|"},{"ref":"XmlGen.Format.Indented.html","title":"XmlGen.Format.Indented","type":"module","doc":""},{"ref":"XmlGen.Format.Indented.html#indentation/2","title":"XmlGen.Format.Indented.indentation/2","type":"function","doc":""},{"ref":"XmlGen.Format.Indented.html#line_break/0","title":"XmlGen.Format.Indented.line_break/0","type":"function","doc":""},{"ref":"XmlGen.Format.None.html","title":"XmlGen.Format.None","type":"module","doc":""},{"ref":"XmlGen.Format.None.html#indentation/2","title":"XmlGen.Format.None.indentation/2","type":"function","doc":""},{"ref":"XmlGen.Format.None.html#line_break/0","title":"XmlGen.Format.None.line_break/0","type":"function","doc":""}]